(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;

/* Package-scope variables */
var SandstormAppList;

(function () {

//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
// packages/sandstorm-ui-applist/applist-common.js                                              //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                //
// TODO(cleanup): Make this class client-only since it does nothing useful on the server.       // 1
SandstormAppList = function(db, quotaEnforcer, highlight) {                                     // 2
  this._filter = new ReactiveVar("");                                                           // 3
  this._sortOrder = new ReactiveVar([["appTitle", 1]]);                                         // 4
  this._staticHost = db.makeWildcardHost("static");                                             // 5
  this._db = db;                                                                                // 6
  this._quotaEnforcer = quotaEnforcer;                                                          // 7
  this._highlight = highlight;                                                                  // 8
  this._uninstalling = new ReactiveVar(false);                                                  // 9
}                                                                                               // 10
                                                                                                // 11
//////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

//////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                              //
// packages/sandstorm-ui-applist/applist-server.js                                              //
//                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                //
Meteor.publish("userPackages", function() {                                                     // 1
  // Users should be able to see packages that are either:                                      // 2
  // 1. referenced by one of their userActions                                                  // 3
  // 2. referenced by one of their grains                                                       // 4
  var self = this;                                                                              // 5
  var db = this.connection.sandstormDb;                                                         // 6
                                                                                                // 7
  // Note that package information, once it is in the database, is static. There's no need to   // 8
  // reactively subscribe to changes to a package since they don't change. It's also unecessary // 9
  // to reactively remove a package from the client side when it is removed on the server, or   // 10
  // when the client stops using it, because the worst case is the client has a small amount    // 11
  // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.     // 12
  // So, we implement this as a cache: the first time each package ID shows up among the user's // 13
  // stuff, we push the package info to the client, and then we never update it.                // 14
  //                                                                                            // 15
  // Alternatively, we could subscribe to each individual package query, but this would waste   // 16
  // lots of server-side resources watching for events that will never happen or don't matter.  // 17
  var hasPackage = {};                                                                          // 18
  var refPackage = function (packageId) {                                                       // 19
    // Ignore dev apps.                                                                         // 20
    if (packageId.lastIndexOf("dev-", 0) === 0) return;                                         // 21
                                                                                                // 22
    if (!hasPackage[packageId]) {                                                               // 23
      hasPackage[packageId] = true;                                                             // 24
      var pkg = db.getPackage(packageId);                                                       // 25
      if (pkg) {                                                                                // 26
        self.added("packages", packageId, pkg);                                                 // 27
      } else {                                                                                  // 28
        console.error(                                                                          // 29
            "shouldn't happen: missing package referenced by user's stuff:", packageId);        // 30
      }                                                                                         // 31
    }                                                                                           // 32
  };                                                                                            // 33
                                                                                                // 34
  // package source 1: packages referred to by actions                                          // 35
  var actions = db.userActions(this.userId);                                                    // 36
  var actionsHandle = actions.observe({                                                         // 37
    added: function(newAction) {                                                                // 38
      refPackage(newAction.packageId);                                                          // 39
    },                                                                                          // 40
    changed: function(oldAction, newAction) {                                                   // 41
      refPackage(newAction.packageId);                                                          // 42
    }                                                                                           // 43
  });                                                                                           // 44
                                                                                                // 45
  // package source 2: packages referred to by grains directly                                  // 46
  var grains = db.userGrains(this.userId);                                                      // 47
  var grainsHandle = grains.observe({                                                           // 48
    added: function(newGrain) {                                                                 // 49
      refPackage(newGrain.packageId);                                                           // 50
    },                                                                                          // 51
    changed: function(oldGrain, newGrain) {                                                     // 52
      refPackage(newGrain.packageId);                                                           // 53
    }                                                                                           // 54
  });                                                                                           // 55
                                                                                                // 56
  this.onStop(function () {                                                                     // 57
    actionsHandle.stop();                                                                       // 58
    grainsHandle.stop();                                                                        // 59
  });                                                                                           // 60
  this.ready();                                                                                 // 61
});                                                                                             // 62
                                                                                                // 63
//////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-ui-applist'] = {
  SandstormAppList: SandstormAppList
};

})();

//# sourceMappingURL=sandstorm-ui-applist.js.map
